#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.23"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
